# -*- coding: utf-8 -*-
"""
Created on Thu Jun  3 21:08:14 2021

@author: ECURBELO
"""
import pandas as pd

from ejemplo_paper import Ejemplo

from tabulate import tabulate

K = 8
xtrue = 2.5
sigmatrue = 4
sigma = 4
ex = Ejemplo( xtrue,sigmatrue,K,sigma)


# N = 10000
T = 100
initial_value_mu = 5
initial_value_sigma = 20
sigma_prop_init = 1

z_grid = 2.9662643134043414e-12

true_expec_x = 1.1007418448964839

true_expec_sig = 4.821591040494352

Ns = [100,1000]

n_simulations = 500

for i in range(n_simulations):
    
    try:
        data = pd.read_csv("sim_expected.csv")
    except:
        data = pd.DataFrame({"N":[],"error_x":[],"error_sigma":[]})
    
    for N in Ns:
        
        data_N = list(data["N"])
        
        data_error_x = list(data["error_x"])
        
        data_error_sigma = list(data["error_sigma"])
    
        ex.new_sampling(initial_value_mu, initial_value_sigma, sigma_prop_init, T, N)
    
        ans = ex.joint_posterior(100,1,False)
        
        relative_error_x = abs(ans[0] - true_expec_x)/true_expec_x
        
        relative_error_sig = abs(ans[1] - true_expec_sig)/true_expec_sig
        
        data_N.append(N)
        
        data_error_x.append(relative_error_x)
        
        data_error_sigma.append(relative_error_sig)
        
        data = pd.DataFrame({"N":data_N,"error_x":data_error_x,"error_sigma":data_error_sigma})
        
        data.to_csv("sim_expected.csv")
        
    print(f"Finish simulation {i}")
    
    
data1 = pd.read_csv("sim_expected.csv")[["N","error_x","error_sigma"]]

mean_errors_x = []

mean_errors_sig = []

for N in Ns:
    
    aux = data1[data1["N"]==N][["error_x","error_sigma"]]
    
    mean_= aux.mean()
    
    mean_errors_x.append(mean_[0])
    
    mean_errors_sig.append(mean_[1])

print(tabulate({"N":Ns,"Errores_x":mean_errors_x,"Errores_sigma":mean_errors_sig}))
    