# -*- coding: utf-8 -*-
"""
Created on Thu Jun  3 21:08:14 2021

@author: ECURBELO
"""
import pandas as pd

from ejemplo_paper import Ejemplo

from tabulate import tabulate

K = 8
xtrue = 2.5
sigmatrue = 4
sigma = 4
ex = Ejemplo( xtrue,sigmatrue,K,sigma)


# N = 10000
T = 100
initial_value_mu = 5
initial_value_sigma = 20
sigma_prop_init = 1

z_grid = 2.9662643134043414e-12

Ns = [100,1000,10000,100000]

n_simulations = 500

for i in range(n_simulations):
    
    try:
        data = pd.read_csv("sim_z.csv")
    except:
        data = pd.DataFrame({"N":[],"error":[]})
    
    for N in Ns:
        
        data_N = list(data["N"])
        
        data_error = list(data["error"])
    
        ex.new_sampling(initial_value_mu, initial_value_sigma, sigma_prop_init, T, N)
    
        z = ex.Z_hat(100)
        
        relative_error = abs(z - z_grid)/z_grid
        
        data_N.append(N)
        
        data_error.append(relative_error)
        
        data = pd.DataFrame({"N":data_N,"error":data_error})
        
        # data["N"] = data_N
        
        # data["error"] = data_error
        
        data.to_csv("sim_z.csv")
        
        # print(relative_error)
    print(f"Finish simulation {i}")
    
    
data1 = pd.read_csv("sim_z.csv")[["N","error"]]

mean_errors = []

for N in Ns:
    
    aux = data1[data1["N"]==N]["error"]
    
    mean_= aux.mean()
    
    mean_errors.append(mean_)

print(tabulate({"N":Ns,"Errores":mean_errors}))
    