# -*- coding: utf-8 -*-
"""
Created on Wed Feb  3 16:49:51 2021

@author: ErnestoAngelCurbeloB
"""

import numpy as np
import matplotlib.pyplot as plt
from matplotlib.patches import Rectangle

# def target(x):
#     return np.cos(x) + 2

class Prop():
    def __init__(self,target,linf,lsup,npoints):
        self.target = target
        self.linf = linf
        self.lsup = lsup
        self.grid = np.linspace(self.linf,self.lsup,npoints)
        self.rectangles = np.zeros((npoints-1,4))
        for i in range(npoints-1):
            if i == 0:
                ev_left = self.target(self.grid[i])
            ev_right = self.target(self.grid[i+1])
            self.rectangles[i,:2] = self.grid[i],self.grid[i+1]
            self.rectangles[i,2] = np.max((ev_left,ev_right))
            self.rectangles[i,3] = self.rectangles[i,2]*(self.rectangles[i,1] - self.rectangles[i,0])
            ev_left = ev_right
        

    def plot(self):
        xplot = np.linspace(self.linf,self.lsup,100,)
        try:
            yplot = self.target(xplot)
        except:
            # print("dio error ;(")
            yplot = [self.target(x) for x in xplot]
        
        prop_x = self.grid
        try:
            prop_y = self.target(prop_x)
        except:
            prop_y = [self.target(x) for x in prop_x ]
        width = prop_x[1] - prop_x[0]
        # print("eta aqui")
        fig = plt.figure(figsize=(10,8))
        ax = fig.add_subplot(1,1,1)
        ax.plot(xplot,yplot,label = "Target")
        ax.bar(self.rectangles[:,0],self.rectangles[:,2],width=width,alpha = 0.5,facecolor="orange",align="edge",edgecolor="black",
               tick_label=np.round(self.rectangles[:,0],1))
        ax.legend(loc="best")
        plt.show()
        return
    
    def sampling(self):
        index = np.arange(self.rectangles.shape[0])
        epsilon = 1e-238
        probs = (self.rectangles[:,3] + epsilon)/(np.sum(self.rectangles[:,3] + epsilon))
        # print(index,probs,sep="\n")
        chosen_ = np.random.choice(index,p=probs)
        inf = self.rectangles[chosen_,0]
        sup = self.rectangles[chosen_,1]
        sample = np.random.random()*(sup - inf) + inf
        return sample,self.rectangles[chosen_,:3]
    
    def evaluate(self,x):
        mask1 = (self.rectangles[:,0] <= x)
        mask2 = (x < self.rectangles[:,1])
        mask3 = mask1*mask2
        index = int(np.where(mask3==True)[0]) 
        evaluation = self.rectangles[index,2]
        return evaluation
    
# linf = 0
# lsup = 20
# npoints = 10
# n_samples = 100000
# initial_point = 3
# cov = 1
# test = Prop(target,linf,lsup,npoints)
# test.plot()
# # print(test.rectangles)
# # print(test.evaluate(1.2))
# from met_hast import met_hast_grid
# a,b = met_hast_grid(target, n_samples, initial_point, cov, linf, lsup, npoints)
# plt.hist(a,bins=50,density = True)
# plt.show()

# # test = Prop(target1, linf, lsup, npoints)
# # test.plot()
